Subject: Re: bug#63920: Emacs Packages should have an output built with emacs-next(-minimal)

From: Maxim Cournoyer <[email-masked]>
Date: Tue, 03 Oct 2023 22:20:59 -0400

retitle 63920 Allow for easily rewriting Emacs packages to use emacs-next
quit

Hello Mekeor,

Liliana Marie Prikler <[email-masked]> writes:

[...]

>> (A workaround is to instead evaluate (load 
>> "consult-register.el").)
>> 
>> I propose:
>> 
>> 1. Introduce a package emacs-next-minimal.
>> 
>> 2. For all Emacs-packages, create one output corresponding to each 
>> Emacs major-version packaged in Guix proper. For example, the 
>> output "emacs-next" would be built with emacs-next-minimal.
>> 
>> What do you think? I'd guess this should be hard to implement, 
>> right?
> This would unnecessarily complicate things over at emacs-build-system.
> Now, emacs-next-minimal itself might be worthwhile (I don't see a
> strong reason as to why, though), but since native compilation was
> introduced to Guix, the recommendation was to compile packages ahead of
> time rather than using the built-in JIT.  To do so, add 
>   --with-input=emacs-minimal=emacs-next
> or use a semantically equivalent options->transformation.  

I agree adding multiple outputs would make things complicated and messy,
and should thus not be the approach pursued.  I think this should be
feasible via package rewriting procedures, like we had in the past for
Python 2 with package-for-python2 or similar, which users can apply to
their Emacs package collection in a manifest file.

A version of it for Emacs has been shared to guix-devel in the past, it
could be reworked, it had some problems still.

I'm renaming the issue to something that should serve as a reminder to
someone to implement this.

-- 
Thanks,
Maxim